var Cus02000_AcompanhamentoDePrecoUnitario = function (ScreenService, MessageService, General, GeneralServices, templateManager, ZhUtil, CUSUtilities){
  /*global Configuration, getLocalVar, moment, Constants*/
  let self = this;
  
  this.defaultValues = function(widget) {
    let firstReport = widget.getField('CD_REPORT_NAME').dataSource.getFirstRow();
    let currentDate = moment().format('DD/MM/YYYY');
    
    widget.currentRow.CD_REPORT_NAME = firstReport.value;
    
    widget.getField('NMGRUPSERV').setValue('');
    widget.getField('DTINICIAL').setValue(currentDate);
    widget.getField('DTFINAL').setValue(currentDate);
    
    widget.getField('NMTIPOCUSTO').reload().then(callback => {
      let typeOfCost = callback.dataset.type_cost_lang;
      
      if(typeOfCost && typeOfCost.length){
        let currentCost = typeOfCost[0];
        widget.currentRow.NMTIPOCUSTO = currentCost.CDTIPOCUSTO + ' | ' + currentCost.NMTIPOCUSTO;
        widget.currentRow.CDTIPOCUSTO = currentCost.CDTIPOCUSTO;
      }
    });
  };  
  
  this.onChangeUnidade = function(args) {
    let widget = args.owner.field.widget;
    
    widget.currentRow.CDFILIAL = widget.getField('NMFILIAL').value() ? widget.getField('NMFILIAL').value().substring(0,4) : '';
    
    widget.getField('NMSERVICO').clearValue();
  };
  
  this.atualizaListaDeServico = function(widget) {
		let currentRow 		= widget.currentRow;
		let nmServicoField = widget.getField('NMSERVICO');
		let grupoServicos = '';
		
		if(currentRow.CDFILIAL) {
		  grupoServicos = 'T';
		}
  
		if (currentRow.NMGRUPSERV && Array.isArray(currentRow.NMGRUPSERV) && currentRow.NMGRUPSERV.length > 0) {
			grupoServicos = currentRow.NMGRUPSERV.join('_');
		}
		
		nmServicoField.dataSourceFilter = [
      {
        name: "CDFILIAL",
        operator: "=",
        value: currentRow.CDFILIAL
      },
      {
        name: "CDGRUPFILI",
        operator: "=",
        value: "T"
      },   
      {
        name: "CDGRUPSERV",
        operator: "=",
        value: grupoServicos || 'T'
      },
      {
        name: "CDOPERADOR",
        operator: "=",
        value: getLocalVar('CDOPERADOR')
      },
      {
        name: "NRORG",
        operator: "=",
        value: getLocalVar('NRORG')
      }
		];
		
		nmServicoField.reload();
  };
  
  this.validaDatas = function (widget) {
    var dataInicial = moment(widget.currentRow.DTINICIAL, 'DD/MM/YYYY');
    var dataFinal 	= moment(widget.currentRow.DTFINAL, 'DD/MM/YYYY');    
    
    
    if (dataInicial && dataFinal && dataFinal < dataInicial) {
      MessageService.showMessageByCode('DATA_INICIAL_FINAL_INVALIDA', null, Constants.errorMessage);
      return false;
    }
    return true;
  };    
  
  this.validateFields = function(widget, row, currentRow) {

    var reportName = widget.currentRow.CD_REPORT_NAME;
    
    if(widget.isValid() && this.validaDatas(widget)) {
      
  		var reportFormats = [
  	    {
          name: "pdf",
          value: "PDF"
  	    },
  	    {
          name: "xlsx",
          value: "XLSX"
  	    }
  		];
  	
  		General.openReportPopup(widget, this.abreRelatorio, [reportName, row, currentRow], reportFormats);  
    }
  };
  
  this.abreRelatorio = function(reportName, row, currentRow) {
    General.openReport('cus_relatorio#/Cus02000_AcompanhamentoDePrecoUnitario', reportName, row);
  }.bind(this);    
  
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus02000_AcompanhamentoDePrecoUnitario', Cus02000_AcompanhamentoDePrecoUnitario);
});